unit oss;

interface
uses crt,dos;

procedure coff;
procedure con;
procedure shadow2(x1,y1,x2,y2,cl:word);
procedure shadow(x1,y1,x2,y2:byte);
procedure rectang(x1,y1,x2,y2:byte;s:char);
procedure effectrectang(x1,y1,x2,y2,time:integer);
procedure WinRectang(x1,y1,x2,y2:byte;deg:boolean);

implementation

procedure coff;
var r:registers;
begin r.ah:=$01;  r.cx:=$2000; intr($10,r);
end;

procedure con;
var r:registers;
begin r.ah:=$01;  r.cx:=$1012; intr($10,r);
end;

procedure shadow2(x1,y1,x2,y2,cl:word);
var
d7,d4,i2,j,i:word;
ekradr:longint;
begin
x1:=x1-2;
x2:=x2-2;
y1:=y1-1;
y2:=y2-1;
d4:=4;
if lo(lastmode)=7 then ekradr:=$B000 else ekradr:=$B800;

    for i2:=y1 to y2 do
    begin
          for i:=x1+2 to x2+2 do
	  begin
	  j:=(y2*160)+i*2-1;
	  if mem[ekradr:j+1]=219 then mem[ekradr:j]:=d4
	  else mem[ekradr:j]:=cl;
	  end;
    y2:=y2-1;
    end;

for i:=y1+1 to y2+1 do
begin
j:=x2*2+160*(i-1)+1;
if mem[ekradr:j+1] = 219 then mem[ekradr:j]:=d4
else mem[ekradr:j]:=cl;
if mem[ekradr:j+3]=219 then mem[ekradr:j+2]:=d4
else mem[ekradr:j+2]:=cl;
end;
end;



procedure shadow(x1,y1,x2,y2:byte);
var
d4,i2,j,i:word;
ekradr:longint;
begin
x1:=x1-2;
x2:=x2-2;
y1:=y1-1;
y2:=y2-1;
d4:=4;
if lo(lastmode)=7 then ekradr:=$B000 else ekradr:=$B800;

    for i2:=y1 to y2 do
    begin
          for i:=x1+2 to x2+2 do
	  begin
	  j:=(y2*160)+i*2-1;
	  if mem[ekradr:j+1]=219 then mem[ekradr:j]:=d4
	  else mem[ekradr:j]:=7;
	  end;
    y2:=y2-1;
    end;

for i:=y1+1 to y2+1 do
begin
j:=x2*2+160*(i-1)+1;
if mem[ekradr:j+1] = 219 then mem[ekradr:j]:=d4
else mem[ekradr:j]:=7;
if mem[ekradr:j+3]=219 then mem[ekradr:j+2]:=d4
else mem[ekradr:j+2]:=7;
end;
end;

procedure rectang(x1,y1,x2,y2:byte;s:char);
var
i,j:integer;
cizgi:string[80];
begin
window(1,1,80,25);
     if (s='c') or (s='C') then begin
	fillchar(cizgi,80,#205);
	cizgi[0]:=chr(x2-x1-1);
	gotoxy(x1,y1);write(chr(201),cizgi,chr(187));
	for i:=y1+1 to y2-1 do
	begin
	gotoxy(x1,i);write(chr(186));
	gotoxy(x2,i);write(chr(186));
	end;
	gotoxy(x1,y2);write(chr(200),cizgi,chr(188));
    end;

    if (s='t') or (s='T') then begin

	fillchar(cizgi,80,#196);
	cizgi[0]:=chr(x2-x1-1);
	gotoxy(x1,y1);write(chr(218),cizgi,chr(191));
	for i:=y1+1 to y2-1 do
	begin
	gotoxy(x1,i);write(chr(179));
	gotoxy(x2,i);write(chr(179));
	end;
	gotoxy(x1,y2);write(chr(192),cizgi,chr(217));
    end;

    if (s='k') or (s='K') then begin

	fillchar(cizgi,80,#45);
	cizgi[0]:=chr(x2-x1-1);
	gotoxy(x1,y1);write(chr(218),cizgi,chr(191));
	for i:=y1+1 to y2-1 do
	begin
	gotoxy(x1,i);write(chr(124));
	gotoxy(x2,i);write(chr(124));
	end;
	gotoxy(x1,y2);write(chr(192),cizgi,chr(217));
    end;
end;


procedure effectrectang(x1,y1,x2,y2,time:integer);
var f1,yy,xx:byte;
begin
if (odd(x2-x1)) then x2:=x2+1;
if (odd(y2-y1)) then y2:=y2+1;
yy:=round((y2-y1)/2)+y1;
coff;

 for f1:=round((y2-y1)/2)+y1 to y2 do
 begin
   window(x1+round((x2-x1)/2),yy,x2-round((x2-x1)/2)+1,f1);clrscr;
   rectang(x1+round((x2-x1)/2),yy,x2-round((x2-x1)/2)+1,f1,'c');
   delay(time*2);
   yy:=yy-1;
 end;

 xx:=round((x2-x1)/2)+x1;

 for f1:=round((x2-x1)/2)+x1 to x2 do
 begin
   shadow2(xx+2,y1+1,f1+3,y2+1,7);window(xx,y1,f1+1,y2);clrscr;
   rectang(xx,y1,f1+1,y2,'c');
   delay(time);
   xx:=xx-1;
 end;

con;
end;

procedure WinRectang(x1,y1,x2,y2:byte;deg:boolean);
var
i,j:integer;
cizgi:string[80];
begin
        window(1,1,80,25);
	fillchar(cizgi,80,#205);
	cizgi[0]:=chr(x2-x1-1);
	gotoxy(x1,y1);
        if deg=true then textcolor(0) else textcolor(15); write(chr(201));
        if deg=true then textcolor(15) else textcolor(0); write(cizgi);
        if deg=true then textcolor(15) else textcolor(0); write(chr(187));
	for i:=y1+1 to y2-1 do
	begin
	if deg=true then textcolor(0) else textcolor(15);gotoxy(x1,i);write(chr(186));
	if deg=true then textcolor(15) else textcolor(0);gotoxy(x2,i);write(chr(186));
	end;
	gotoxy(x1,y2);
        if deg=true then textcolor(0) else textcolor(15); write(chr(200));
        if deg=true then textcolor(0) else textcolor(15); write(cizgi);
        if deg=true then textcolor(15) else textcolor(0); write(chr(188));
end;

end.